Main Page Widgets Namespaces Book

# Gtk::Clipboard Class Reference

Inheritance diagram for Gtk::Clipboard:

[legend]
List of all members.

## Public Types

typedef SigC::Slot2< void, SelectionData&, guint > | SlotGet
| e.g.: void on_get(Gtk::SelectionData& selection_data, guint info);
typedef SigC::Slot0<void> | SlotClear
| e.g.: void on_clear();
typedef SigC::Slot1< void, const SelectionData& > | SlotReceived
| e.g.: void on_received(const SelectionData& selection_data);
typedef SigC::Slot1< void, const Glib::ustring& > | SlotTextReceived
| e.g.: void on_textreceived(const Glib::ustring& text);

## Public Member Functions

virtual | ~Clipboard ()
GtkClipboard* | gobj ()
| Provides access to the underlying C GObject.
const GtkClipboard* | gobj () const
| Provides access to the underlying C GObject.
GtkClipboard* | gobj_copy ()
Glib::RefPtr<Gdk::Display> | get_display ()
| Gets the Gdk::Display associated with clipboard.
Glib::RefPtr<const Gdk::Display> | get_display () const
| Gets the Gdk::Display associated with clipboard.
bool | set (const ArrayHandle_TargetEntry& targets, const SlotGet& slot_get, const SlotClear& slot_clear)
| Virtually sets the contents of the specified clipboard by providing a list of supported formats for the clipboard data and a function to call to get the actual data when it is requested.
Glib::RefPtr<Glib::Object> | get_owner ()
| If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().
Glib::RefPtr<const Glib::Object> | get_owner () const
| If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().
void | clear ()
| Clears the contents of the clipboard.
void | set_text (const Glib::ustring& text)
| Sets the contents of the clipboard to the given UTF-8 string.
void | request_contents (const Glib::ustring& target, const SlotReceived& slot)
void | request_targets (const SlotReceived& slot)
void | request_text (const SlotTextReceived& slot)
SelectionData | wait_for_contents (const Glib::ustring& target) const
| Requests the contents of the clipboard using the given target.
Glib::ustring | wait_for_text () const
| Requests the contents of the clipboard as text and converts the result to UTF-8 if necessary.
bool | wait_is_text_available () const
| Test to see if there is text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the names: STRING, TEXT, COMPOUND_TEXT, UTF8_STRING.

## Static Public Member Functions

Glib::RefPtr<Clipboard> | get (GdkAtom selection=GDK_SELECTION_CLIPBOARD)
| Returns the clipboard object for the given selection.
Glib::RefPtr<Clipboard> | get_for_display (const Glib::RefPtr<Gdk::Display>& display, GdkAtom selection=GDK_SELECTION_CLIPBOARD)
| Returns the clipboard object for the given selection.

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gtk::Clipboard> | wrap (GtkClipboard* object, bool take_copy=false)

## Member Typedef Documentation

typedef SigC::Slot0<void> Gtk::Clipboard::SlotClear

| e.g.: void on_clear();

typedef SigC::Slot2<void, SelectionData&, guint> Gtk::Clipboard::SlotGet

| e.g.: void on_get(Gtk::SelectionData& selection_data, guint info);

typedef SigC::Slot1<void, const SelectionData&> Gtk::Clipboard::SlotReceived

| e.g.: void on_received(const SelectionData& selection_data);

typedef SigC::Slot1<void, const Glib::ustring&> Gtk::Clipboard::SlotTextReceived

| e.g.: void on_textreceived(const Glib::ustring& text);

## Constructor & Destructor Documentation

virtual Gtk::Clipboard::~Clipboard | ( |  | ) | `[virtual]`

## Member Function Documentation

void Gtk::Clipboard::clear | ( |  | ) |

| Clears the contents of the clipboard. Generally this should only be called between the time you call gtk_clipboard_set_with_owner() or gtk_clipboard_set_with_data(), and when the clear_func you supplied is called. Otherwise, the clipboard may be owned by someone else.

Glib::RefPtr<Clipboard> Gtk::Clipboard::get | ( | GdkAtom | selection = GDK_SELECTION_CLIPBOARD | ) | `[static]`

Returns the clipboard object for the given selection.

See gtk_clipboard_get_for_display() for complete details.

Parameters:

  selection | A Gdk::Atom which identifies the clipboard to use.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time and cannot be freed.

Glib::RefPtr<const Gdk::Display> Gtk::Clipboard::get_display | ( |  | ) | const

Gets the Gdk::Display associated with clipboard.

Returns:
  The Gdk::Display associated with clipboard

Since: 2.2.

Glib::RefPtr<Gdk::Display> Gtk::Clipboard::get_display | ( |  | ) |

Gets the Gdk::Display associated with clipboard.

Returns:
  The Gdk::Display associated with clipboard

Since: 2.2.

Glib::RefPtr<Clipboard> Gtk::Clipboard::get_for_display | ( | const Glib::RefPtr<Gdk::Display>& | display,
|  | GdkAtom | selection = GDK_SELECTION_CLIPBOARD
| ) | `[static]`

Returns the clipboard object for the given selection.

Cut/copy/paste menu items and keyboard shortcuts should use the default clipboard, returned by passing Gdk::SELECTION_CLIPBOARD for selection . (Gdk::NONE is supported as a synonym for GDK_SELECTION_CLIPBOARD for backwards compatibility reasons.) The currently-selected object or text should be provided on the clipboard identified by Gdk::SELECTION_PRIMARY. Cut/copy/paste menu items conceptually copy the contents of the Gdk::SELECTION_PRIMARY clipboard to the default clipboard, i.e. they copy the selection to what the user sees as the clipboard.

(Passing Gdk::NONE is the same as using `gdk_atom_intern ("CLIPBOARD", `false`)`. See

http://www.freedesktop.org/standards/clipboards.txt for a detailed discussion of the "CLIPBOARD" vs. "PRIMARY" selections under the X window system. On Win32 the Gdk::SELECTION_PRIMARY clipboard is essentially ignored.)

It's possible to have arbitrary named clipboards; if you do invent new clipboards, you should prefix the selection name with an underscore (because the ICCCM requires that nonstandard atoms are underscore-prefixed), and namespace it as well. For example, if your application called "Foo" has a special-purpose clipboard, you might call it "_FOO_SPECIAL_CLIPBOARD".

Parameters:

  display | The display for which the clipboard is to be retrieved or created.
  selection | A Gdk::Atom which identifies the clipboard to use.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time and cannot be freed.

Since: 2.2.

Glib::RefPtr<const Glib::Object> Gtk::Clipboard::get_owner | ( |  | ) | const

If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().

Returns:
  The owner of the clipboard, if any; otherwise `0`.

Glib::RefPtr<Glib::Object> Gtk::Clipboard::get_owner | ( |  | ) |

If the clipboard contents callbacks were set with gtk_clipboard_set_with_owner(), and the gtk_clipboard_set_with_data() or gtk_clipboard_clear() has not subsequently called, returns the owner set by gtk_clipboard_set_with_owner().

Returns:
  The owner of the clipboard, if any; otherwise `0`.

const GtkClipboard* Gtk::Clipboard::gobj | ( |  | ) | const`[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GtkClipboard* Gtk::Clipboard::gobj | ( |  | ) | `[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GtkClipboard* Gtk::Clipboard::gobj_copy | ( |  | ) |

void Gtk::Clipboard::request_contents | ( | const Glib::ustring& | target,
|  | const SlotReceived& | slot
| ) |

void Gtk::Clipboard::request_targets | ( | const SlotReceived& | slot | ) |

void Gtk::Clipboard::request_text | ( | const SlotTextReceived& | slot | ) |

bool Gtk::Clipboard::set | ( | const ArrayHandle_TargetEntry& | targets,
|  | const SlotGet& | slot_get,
|  | const SlotClear& | slot_clear
| ) |

Virtually sets the contents of the specified clipboard by providing a list of supported formats for the clipboard data and a function to call to get the actual data when it is requested.

Parameters:

  targets | Information about the available forms for the clipboard data.
  slot_get | method to call to get the actual clipboard data.
  slot_clear | When the clipboard contents are set again, this method will be called, and slot_get will not be subsequently called.

Returns:
  true if setting the clipboard data succeeded. If setting the clipboard data failed then the provided callback methods will be ignored.

void Gtk::Clipboard::set_text | ( | const Glib::ustring& | text | ) |

Sets the contents of the clipboard to the given UTF-8 string.

GTK+ will make a copy of the text and take responsibility for responding for requests for the text, and for converting the text into the requested format.

Parameters:

  text | A UTF-8 string.

SelectionData Gtk::Clipboard::wait_for_contents | ( | const Glib::ustring& | target | ) | const

Requests the contents of the clipboard using the given target.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Parameters:

  target | The form into which the clipboard owner should convert the selection.

Returns:
  A GtkSelectionData object, which will be invalid if retrieving the given target failed.

Glib::ustring Gtk::Clipboard::wait_for_text | ( |  | ) | const

Requests the contents of the clipboard as text and converts the result to UTF-8 if necessary.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

Returns:
  A UTF-8 string, which is empty if retrieving the selection data failed. (This could happen for various reasons, in particular if the clipboard was empty or if the contents of the clipboard could not be converted into text form.).

bool Gtk::Clipboard::wait_is_text_available | ( |  | ) | const

Test to see if there is text available to be pasted This is done by requesting the TARGETS atom and checking if it contains any of the names: STRING, TEXT, COMPOUND_TEXT, UTF8_STRING.

This function waits for the data to be received using the main loop, so events, timeouts, etc, may be dispatched during the wait.

This function is a little faster than calling gtk_clipboard_wait_for_text() since it doesn't need to retrieve the actual text.

Returns:
  `true` is there is text available, `false` otherwise.

## Friends And Related Function Documentation

Glib::RefPtr<Gtk::Clipboard> wrap | ( | GtkClipboard* | object,
|  | bool | take_copy = false
| ) | `[related]`

The documentation for this class was generated from the following file:

- clipboard.h